﻿<template>
    <v-app>
        <v-container>
            <keep-alive>
                <v-form ref="form"
                        v-model="valid"
                        lazy-validation>
                    <v-row>
                        <v-col cols="12">
                            <v-text-field v-model="title"
                                          :rules="titleRules"
                                          label="Название задачи"
                                          required></v-text-field>
                        </v-col>
                        <v-col cols="12">
                            <v-dialog ref="dialogStart"
                                      v-model="modalStart"
                                      :return-value.sync="startDate"
                                      persistent
                                      width="290px">
                                <template v-slot:activator="{ on, attrs }">
                                    <v-text-field v-model="startDate"
                                                  label="Start date"
                                                  prepend-icon="mdi-calendar"
                                                  readonly
                                                  v-bind="attrs"
                                                  v-on="on"></v-text-field>
                                </template>
                                <v-date-picker v-model="startDate"
                                               scrollable>
                                    <v-spacer></v-spacer>
                                    <v-btn text
                                           color="primary"
                                           @click="modalStart = false">
                                        Cancel
                                    </v-btn>
                                    <v-btn text
                                           color="primary"
                                           @click="$refs.dialogStart.save(startDate)">
                                        OK
                                    </v-btn>
                                </v-date-picker>
                            </v-dialog>
                        </v-col>
                        <v-col cols="12">
                            <v-dialog ref="dialogEstimated"
                                      v-model="modalEstimated"
                                      :return-value.sync="estimatedDate"
                                      persistent
                                      width="290px">
                                <template v-slot:activator="{ on, attrs }">
                                    <v-text-field v-model="estimatedDate"
                                                  label="Estimated date"
                                                  prepend-icon="mdi-calendar"
                                                  readonly
                                                  v-bind="attrs"
                                                  v-on="on"></v-text-field>
                                </template>
                                <v-date-picker v-model="estimatedDate"
                                               scrollable>
                                    <v-spacer></v-spacer>
                                    <v-btn text
                                           color="primary"
                                           @click="modalEstimated = false">
                                        Cancel
                                    </v-btn>
                                    <v-btn text
                                           color="primary"
                                           @click="$refs.dialogEstimated.save(estimatedDate)">
                                        OK
                                    </v-btn>
                                </v-date-picker>
                            </v-dialog>
                        </v-col>
                        <v-col cols="12">
                            <v-select v-model="selectedProject"
                                      :items="projectArr"
                                      item-text="title"
                                      item-value="id"
                                      :menu-props="{ maxHeight: '400' }"
                                      label="Выберите проект"
                                      persistent-hint>
                            </v-select>
                        </v-col>
                        <v-col cols="12">
                            <v-select v-model="selectedEmployee"
                                      :items="employeeInProject"
                                      item-text="userName"
                                      item-value="id"
                                      :menu-props="{ maxHeight: '400' }"
                                      label="Выберите сотрудника"
                                      persistent-hint>
                            </v-select>
                        </v-col>
                        <v-col cols="12">
                            <v-btn :disabled="!valid"
                                   color="success"
                                   class="mr-4"
                                   @click="onTask">
                                Отправить
                            </v-btn>
                        </v-col>
                    </v-row>
                </v-form>
            </keep-alive>
        </v-container>
    </v-app>
</template>

<script>
    import { mapActions, mapGetters } from 'vuex'

    export default {
        data() {
            return {
                valid: true,
                title: '',
                titleRules: [
                    v => !!v || 'Title is required',
                ],
                startDate: new Date().toISOString().substr(0, 10),
                estimatedDate: new Date().toISOString().substr(0, 10),
                modalStart: false,
                modalEstimated: false,
                projectArr: [],
                employeeArr: [],
                userArr: [],
                employeeInProject: [],
                selectedProject: 0,
                selectedEmployee: 0,
            }
        },
        async created() {
            this.onProjectAllWithDetailsData();
            this.onEmployeeAllData();
            this.onUserData();
        },
        computed: {
            ...mapGetters('user', ['getUserData']),
            ...mapGetters('project', ['getProjectAllData']),
            ...mapGetters('employee', ['getEmployeeAllData']),
        },
        methods: {
            ...mapActions('user', ['onUserData']),
            ...mapActions('project', ['onProjectAllWithDetailsData']),
            ...mapActions('employee', ['onEmployeeAllData']),
            validate() {
                this.$refs.form.validate()
            },
            async onTask() {
                await this.validate()
                if (this.valid === true) {
                    let title = this.title
                    let startDate = this.startDate
                    let estimatedDate = this.estimatedDate
                    let projectId = this.selectedProject
                    let employeeId = this.selectedEmployee
                    this.$store
                        .dispatch('task/taskCreate',
                            {
                                title,
                                startDate,
                                estimatedDate,
                                projectId,
                                employeeId
                            }
                        )
                        .then(() => {
                            this.$router.push({ name: 'Home' })
                        })
                        .catch()
                } else return
            }
        },
        watch: {
            selectedProject() {
                if (this.selectedProject !== 0) {
                    let project = this.projectArr.find(x => x.id === this.selectedProject);
                    let employeesInproject = this.employeeArr.filter(x => project.employees.includes(x.id));
                    employeesInproject.forEach(x => x["userName"] = this.userArr.find(y => y.id === x.userId).userName);
                    this.employeeInProject = employeesInproject;
                }
            },
            getUserData() {
                this.userArr = this.getUserData;
            },
            getProjectAllData() {
                this.projectArr = this.getProjectAllData;
            },
            getEmployeeAllData() {
                this.employeeArr = this.getEmployeeAllData;
            }
        }
    }
</script>